package gap.enekow.dlappse;

import android.bluetooth.BluetoothSocket;
import android.os.Handler;
import android.util.Log;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * Created by enekow on 30/05/2015.
 */
public class Connection extends Thread {

    String TAG = "GAKOA";

    private final BluetoothSocket mmSocket;
    private final InputStream mmInStream;
    private final OutputStream mmOutStream;

    Handler mHandler;

    public Connection(BluetoothSocket socket, Handler handler) {
        mmSocket = socket;
        mHandler = handler;
        InputStream tmpIn = null;
        OutputStream tmpOut = null;

        // Get the input and output streams, using temp objects because
        // member streams are final
        try {
            tmpIn = socket.getInputStream();
            tmpOut = socket.getOutputStream();
        } catch (IOException e) { }

        mmInStream = tmpIn;
        mmOutStream = tmpOut;

    }

    public void run() {
        byte[] buffer = new byte[1024];  // buffer store for the stream
        int bytes; // bytes returned from read()
        StringBuilder sb = new StringBuilder();
        Log.v("GAKOA", "Entzuten...");
        // Entzuten mantendu errorea gertatzen ez den bitartean
        while (true) {
            try {
                    bytes = mmInStream.read(buffer);
                    byte[] readBuf = (byte[]) buffer;
                    String strIncom = new String(readBuf, 0, bytes);  // create string from bytes array
                    sb.append(strIncom);     // append string
                    int endOfLineIndex = sb.indexOf("\n"); // determine the end-of-line
                    if (endOfLineIndex > 0) {
                        // add the current string to eol to a local string
                        String sbprint = sb.substring(0, endOfLineIndex);

                        // get the start and end indexes of the heading
                        //  int startHeading = sb.indexOf("HE");
                        // int endHeading = sb.indexOf("/HE");
                        //Jasotako mezua UIera bidali
                        mHandler.obtainMessage(Constants.MESSAGE_READ, sbprint).sendToTarget();
                        sb.delete(0, sb.length());
                    }
            } catch (IOException e) {
                Log.e(TAG, "Irakurketan arazoren bat gertatu da.");
                break;
            }
        }
    }

    /* Call this from the main activity to send data to the remote device */
    public void write(String s) {
        try {
            mmOutStream.write(s.getBytes());
        } catch (IOException e) { }
    }

    /* Call this from the main activity to shutdown the connection */
    public void cancel() {
        try {
            mmSocket.close();
        } catch (IOException e) { }
    }
}