package gap.enekow.dlappse;

/**
 * Created by enekow on 27/05/2015.
 */

import android.app.Activity;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.TextView;

import static gap.enekow.dlappse.R.id.seekBar_velocity;


public class ManualFragment extends Fragment {

    String TAG = "GAKOA";

    ManualFragmentListener mCallback;

    public interface ManualFragmentListener {
        void sendCommand(int cmd, String data);
        void setStartStop_Start();
        void setStartStop_Stop();
    }

    @Override
    public void onAttach(Activity activity) {
        super.onAttach(activity);
        // This makes sure that the container activity has implemented
        // the callback interface. If not, it throws an exception
        try {
            mCallback = (ManualFragmentListener) activity;
        } catch (ClassCastException e) {
            throw new ClassCastException(activity.toString()
                    + " must implement OnHeadlineSelectedListener");
        }
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        final View rootView = inflater.inflate(R.layout.fragment_manual, container, false);

        // Eskubi (>) botoia sakatua dagoen bitartean eskubira komandoa bidali eta askatzean stop
        Button btnRight = (Button) rootView.findViewById(R.id.btn_mRigth);
        btnRight.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                switch (event.getAction()) {
                    case MotionEvent.ACTION_DOWN:
                        Log.v(TAG, "Eskubira sakatua");
                        mCallback.sendCommand(Constants.GO_RIGHT, String.valueOf(getVelocity()-1));
                        break;
                    case MotionEvent.ACTION_UP:
                        Log.v(TAG, "Eskubira askatua");
                        mCallback.sendCommand(Constants.STOP, null);
                        break;
                }
                return false;
            }
        });

        // Dena eskubi (>>) botoia sakatzean eskubira komandoa bidali
        Button btnAllRight = (Button) rootView.findViewById(R.id.btn_mAllRight);
        btnAllRight.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.v(TAG, "Dena eskubira sakatua");
                mCallback.sendCommand(Constants.GO_RIGHT, String.valueOf(getVelocity() - 1));
                mCallback.setStartStop_Stop();
            }
        });

        // Ezker (<) botoia sakatua dagoen bitartean ezkerrera komandoa bidali eta askatzean stop
        Button btnLeft = (Button) rootView.findViewById(R.id.btn_mLeft);
        btnLeft.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                switch (event.getAction()) {
                    case MotionEvent.ACTION_DOWN:
                        Log.v(TAG, "Ezkerrera sakatua");
                        mCallback.sendCommand(Constants.GO_LEFT, String.valueOf(getVelocity() - 1));
                        break;
                    case MotionEvent.ACTION_UP:
                        Log.v(TAG, "Ezkerrera askatua");
                        mCallback.sendCommand(Constants.STOP, null);
                        break;
                }
                return false;
            }
        });

        //Dena ezkerrera (<<) botoia sakatzean eskubira komandoa bidali
        Button btnAllLeft = (Button) rootView.findViewById(R.id.btn_mAllLeft);
        btnAllLeft.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.v(TAG, "Dena ezkerrera sakatua");
                mCallback.sendCommand(Constants.GO_LEFT, String.valueOf(getVelocity() - 1));
                mCallback.setStartStop_Stop();
            }
        });

        //Stop botoia sakatzean gelditzeko komandoa bidali
        Button btnStop = (Button) rootView.findViewById(R.id.btn_mStop);
        btnStop.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.v(TAG, "Stop sakatua");
                mCallback.sendCommand(Constants.STOP, null);
            }
        });

        //Shot botoia sakatzean argazkia ateratzeko komandoa bidali
        Button btnShot = (Button) rootView.findViewById(R.id.btn_mShot);
        btnShot.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Log.v(TAG, "Shot sakatua");
                mCallback.sendCommand(Constants.TAKE_A_SHOT, null);
            }
        });

        TextView txtSpeed = (TextView) rootView.findViewById(R.id.txt_velocity);
        txtSpeed.setText(getActivity().getString(R.string.txt_speed) + " 5");
        SeekBar seekVel = (SeekBar) rootView.findViewById(seekBar_velocity);
        seekVel.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
            @Override
            public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser) {
                TextView txtSpeed = (TextView) getView().findViewById(R.id.txt_velocity);
                txtSpeed.setText(getActivity().getString(R.string.txt_speed) + " " + getVelocity());
            }

            @Override
            public void onStartTrackingTouch(SeekBar seekBar) {
            }

            @Override
            public void onStopTrackingTouch(SeekBar seekBar) {

            }
        });


        btnAllLeft.setEnabled(false);
        btnAllRight.setEnabled(false);
        btnLeft.setEnabled(false);
        btnRight.setEnabled(false);
        btnShot.setEnabled(false);
        btnStop.setEnabled(false);

        return rootView;
    }

    public void disableButtons(){

    }

    //Abiadura aukeratzeko SeekBar-a irakurri eta balioa itzuli (1-10)
    public int getVelocity(){
        SeekBar seekVel = (SeekBar) getView().findViewById(seekBar_velocity);
        return seekVel.getProgress()+1;
    }


}