package gap.enekow.dlappse;

import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Configuration;
import android.content.res.Resources;
import android.os.Bundle;
import android.preference.ListPreference;
import android.preference.Preference;
import android.preference.PreferenceActivity;
import android.preference.PreferenceManager;
import android.util.DisplayMetrics;
import android.util.Log;

import java.util.Locale;

/**
 * A {@link PreferenceActivity} that presents a set of application settings.
 * <p>
 * See <a href="http://developer.android.com/design/patterns/settings.html">
 * Android Design: Settings</a> for design guidelines and the <a
 * href="http://developer.android.com/guide/topics/ui/settings.html">Settings
 * API Guide</a> for more information on developing a Settings UI.
 */
public class SettingsActivity extends PreferenceActivity
        implements Preference.OnPreferenceChangeListener {

    String TAG = "GAKOA";
    String lang;
    SharedPreferences preferences;
    String prevLang;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // Add 'general' preferences, defined in the XML file
        // TODO: Add preferences from XML
        addPreferencesFromResource(R.xml.pref_general);

        // For all preferences, attach an OnPreferenceChangeListener so the UI summary can be
        // updated when the preference changes.
        // TODO: Add preferences
        bindPreferenceSummaryToValue(findPreference(getString(R.string.pref_camera_key)));
        bindPreferenceSummaryToValue(findPreference(getString(R.string.pref_lenght_key)));
        bindPreferenceSummaryToValue(findPreference(getString(R.string.pref_dollyName_key)));
        bindPreferenceSummaryToValue(findPreference(getString(R.string.pref_fps_key)));
        bindPreferenceSummaryToValue(findPreference(getString(R.string.pref_language_key)));
    }

    /**
     * Attaches a listener so the summary is always updated with the preference value.
     * Also fires the listener once, to initialize the summary (so it shows up before the value
     * is changed.)
     */
    private void bindPreferenceSummaryToValue(Preference preference) {
        // Set the listener to watch for value changes.
        preference.setOnPreferenceChangeListener(this);

        // Trigger the listener immediately with the preference's
        // current value.
        onPreferenceChange(preference,
                PreferenceManager
                        .getDefaultSharedPreferences(preference.getContext())
                        .getString(preference.getKey(), ""));
    }

    @Override
    public boolean onPreferenceChange(Preference preference, Object value) {
        String stringValue = value.toString();

        if (preference instanceof ListPreference) {
            // For list preferences, look up the correct display value in
            // the preference's 'entries' list (since they have separate labels/values).
            ListPreference listPreference = (ListPreference) preference;
            int prefIndex = listPreference.findIndexOfValue(stringValue);
            if (prefIndex >= 0) {
                preference.setSummary(listPreference.getEntries()[prefIndex]);
            }
        } else {
            // For other preferences, set the summary to the value's simple string representation.
            preference.setSummary(stringValue);
        }

        /** Hizkuntza aldaketak detektatu */
        if(preference.getKey().equals("language")){
            preferences = PreferenceManager.getDefaultSharedPreferences(this);
            prevLang = preferences.getString(getString(R.string.pref_language_key), "en");
            if(value.equals("es")){
                lang="es";
            }else if(value.equals("en")){
                lang="en";
            }else if(value.equals("eu")){
                lang="eu";
            }

            if (!lang.equals(prevLang)){
                //Toast.makeText(this, "Hizkuntza aldatu da", Toast.LENGTH_SHORT).show();
                Log.v(TAG, "Hizkuntza aldatu da");
                prevLang = lang;
                setLocale(lang);
            }
        }
        return true;
    }

    @Override
    protected void onStop(){
        super.onStop();
    }

    Locale myLocale;
    public void setLocale(String lang) {
        myLocale = new Locale(lang);
        Resources res = getResources();
        DisplayMetrics dm = res.getDisplayMetrics();
        Configuration conf = res.getConfiguration();
        conf.locale = myLocale;
        res.updateConfiguration(conf, dm);
        Intent refresh = new Intent(this, SettingsActivity.class);
        startActivity(refresh);
        finish();
    }
}