
/**************************************************************************************
	
		Copyright 2015 Eneko Irazusta Aizpurua 

		Licensed under the Apache License, Version 2.0 Apache License;
		you may not use this file except in compliance with the License.
		You may obtain a copy of the License at

		    http://www.apache.org/licenses/LICENSE-2.0

		Unless required by applicable law or agreed to in writing, software
		distributed under the License is distributed on an "AS IS" BASIS,
		WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
		See the License for the specific language governing permissions and
		limitations under the License.

**************************************************************************************/

#ifndef StepperMotor_h
#define StepperMotor_h

#include "Arduino.h"

class StepperMotor {
private:
	/*Shield parameters*/
	int _pwm_chA;
	int _pwm_chB;
	int _dir_chA;
	int _dir_chB;
	int _brake_chA;
	int _brake_chB;
	/*Motor parameters*/
	int _steps;
	int _one_rpm_delay;
	/*Internal functions*/
	void goDir0(int delaylegnth);
	void goDir1(int delaylegnth);

public:

	StepperMotor(); 
	StepperMotor(int pin_pwm_chA, int pin_pwm_chB, int pin_dir_chA, int pin_dir_chB, int pin_brake_chA, int pin_brake_chB, int _steps);
	void speed(int rpm, int dir); 
	int step(int dir);
	int steps(int steeps, int dir);
	void steps(int steeps, int rpm, int dir);
	void stop();
} ;

#endif



